/*-
 * Copyright (c) 2000-2002 Andrey Simonenko
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *   @(#)$Id: kipfil.h,v 1.4.2.3 2002/10/28 21:40:39 simon Exp $
 */


#ifndef IPA_KIPFIL_H
#define IPA_KIPFIL_H

#include "system.h"

#ifdef WITH_IPFIL

#define IPFIL_NUMBER_MAX UINT_MAX

#if IPF_VERSION > 30400
# define IPFIL_GROUP_MAX UINT_MAX
#else
# define IPFIL_GROUP_MAX USHRT_MAX
#endif /* IPF_VERSION > 30400 */

struct kipfil {
	u_int		group;		/* group number */
	char		type;		/* 'i' or 'o' */
	u_quad_t	*bcnt;		/* array of byte counters */
	u_int		size;		/* size of previous array */
	u_int		next_set;	/* next free entry in bcnt array */
};

extern struct kipfil	*kipfil;
extern u_int		nkipfil;
extern u_quad_t		kipfil_bcnt_max;
extern int		kipfil_init(void);
extern void		kipfil_close(void);
extern int		kipfil_read_table(void);


#endif /* WITH_IPFIL */

#endif /* IPA_KIPFIL_H */
